]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Release of v0.20111018
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index 62310a7293ab5485839cccf1162d39b9acf184ff..9514f05cdffda75bc27e7ea90f5012415e0ec02b 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -1,11 +1,33 @@
 #!/bin/sh
 
-#set -x
+[ "$VCSH_DEBUG" = '1' ] && set -x
 
 SELF=$(basename $0)
-[ -z $XDG_CONFIG_HOME ] && XDG_CONFIG_HOME="$HOME/.config"
+
+[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+for check_directory in $XDG_CONFIG_HOME $XDG_CONFIG_HOME/vcsh $XDG_CONFIG_HOME/vcsh/repo.d
+do
+       if [ ! -d "$check_directory" ]; then
+               if [ -e "$check_directory" ]; then
+                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
+                       exit 2
+               else
+                       mkdir $check_directory || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
+               fi
+       fi
+done
+
 VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
+debug() {
+       [ "$VCSH_DEBUG" = '1' ] && echo "$SELF: debug: $1"
+}
+
+verbose() {
+       if [ "$VCSH_DEBUG" = '1' ] || [ "$VCSH_VERBOSE" = '1' ]; then echo "$SELF: verbose: $1"; fi
+}
+
+#   use <repo>     Use this repository
 help() {
        echo "usage: $SELF <args>
 
@@ -13,7 +35,6 @@ help() {
 
    list           List all repos
 
-   use <repo>     Use this repository
    run <repo>
        <command>  Use this repository
 
@@ -25,6 +46,7 @@ help() {
 }
 
 use() {
+       verbose "use() begin"
        REPO_NAME="$1"
        GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
 
@@ -36,10 +58,12 @@ use() {
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
        export VCSH_DIRECTORY="$REPO_NAME"
+       verbose "use() end"
 }
 
 init() {
-       [[ -e $GIT_DIR ]] &&
+       verbose "init() begin"
+       [ -e "$GIT_DIR" ] &&
                echo "$SELF: fatal: $GIT_DIR exists" &&
                return 21
        export GIT_WORK_TREE="$HOME"
@@ -50,6 +74,7 @@ init() {
        cd $GIT_WORK_TREE
        git init
        git config core.worktree $GIT_WORK_TREE
+       verbose "init() end"
 }
 
 leave() {
@@ -58,40 +83,52 @@ leave() {
        unset VCSH_DIRECTORY
 }
 
-if [ "$1" = 'help' ] || [ $# -eq 0 ]; then
+if [ "$1" = 'help' ] || [ "$#" -eq 0 ]; then
        help
        [ "$1" = 'help' ]
-       return $?
+       exit $?
 
 elif [ "$1" = 'list' ]; then
+       verbose "list begin"
        for i in $VCSH_BASE/*.git; do
                echo $(basename $i .git)
        done
-       return 0
+       verbose "list end"
+       exit 0
 
 elif [ "$1" = 'run' ]; then
+       verbose "run begin"
        use $2
        shift 2
        "$@"
        leave
-       return 0
-
-elif [ "$1" = 'use' ]; then
-       if [[ -o NO_IGNORE_EOF ]]; then
-               export VCSH_NO_IGNORE_EOF=1
-               setopt IGNORE_EOF
-               vcsh_exit() {vcsh exit; zle reset-prompt;}
-               zle -N vcsh_exit
-               bindkey '^d' 'vcsh_exit'
-       fi
-       use $2
-       buildPS1
-       return 0
+       verbose "run end"
+       exit 0
+
+#elif [ "$1" = 'use' ]; then
+#      verbose "use begin"
+#      if [ -n "$ZSH_VERSION" ]; then
+#              if [ -o NO_IGNORE_EOF ]; then
+#                      export VCSH_NO_IGNORE_EOF=1
+#                      setopt IGNORE_EOF
+#              fi
+#              vcsh_exit() {
+#                      vcsh exit;
+#                      zle reset-prompt;
+#              }
+#              zle -N vcsh_exit
+#              bindkey '^d' 'vcsh_exit'
+#      fi
+#      use $2
+#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
+#      verbose "use end"
+#      exit 0
 
 elif [ "$1" = 'clone' ]; then
+       verbose "clone begin"
        GIT_REMOTE="$2"
        REPO_NAME="$3"
-       [[ -z $REPO_NAME ]] && REPO_NAME=$(basename $GIT_REMOTE .git)
+       [ -z "$REPO_NAME" ] && REPO_NAME=$(basename $GIT_REMOTE .git)
        export REPO_NAME
        export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
        init
@@ -100,35 +137,41 @@ elif [ "$1" = 'clone' ]; then
        git config branch.master.remote origin
        git config branch.master.merge  refs/heads/master
        git fetch
-       for i in $(git ls-tree -r origin/master | awk '{print $4}'); do
-       [[ -e $i ]] &&
-               echo "$SELF: error: $i exists." &&
-               CONFLICT=1;
+       for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+               [ -e "$object" ] &&
+                       echo "$SELF: error: $object exists." &&
+                       VCSH_CONFLICT=1;
        done
-       [[ -n $CONFLICT ]] &&
+       [ "$VCSH_CONFLICT" = '1' ] &&
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
                exit 3
        git merge origin/master
-       vcsh use $REPO_NAME
+#      vcsh use $REPO_NAME
+       verbose "clone end"
 
 elif [ "$1" = 'init' ]; then
+       verbose "init begin"
        export REPO_NAME="$2"
        export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
        init
-       vcsh use $REPO_NAME
+#      vcsh use $REPO_NAME
+       verbose "init end"
 
 elif [ "$1" = 'exit' ]; then
-       if [[ $VCSH_NO_IGNORE_EOF -gt 0 ]]; then
+       verbose "exit begin"
+       if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
                unset VCSH_NO_IGNORE_EOF
                setopt NO_IGNORE_EOF
        fi
        leave
-       buildPS1
-       return 0
+       [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
+       verbose "exit end"
+       exit 0
 
 else
+       verbose "defaulting to calling help()"
        help
-       return 3
+       exit 3
 
 fi